--[[
	Anything trivial that I need for debug
--]]

local _G = _G;

function SN_ArrayTest()

	if ( SN_DEBUG )
	then
		DEFAULT_CHAT_FRAME:AddMessage("SN_ArrayTest driven");
	end;

	DEFAULT_CHAT_FRAME:AddMessage("Check LUA array behaviour");
	local test_array = {};
	test_array.var1 = true;
	test_array.subarray = {};
	test_array.subarray["fred"] = "jim";

	DEFAULT_CHAT_FRAME:AddMessage("Before reset attempt: "..test_array.subarray["fred"]);

	test_array = {};
	DEFAULT_CHAT_FRAME:AddMessage("Test array was reset");

	if (test_array.subarray)
	then
		DEFAULT_CHAT_FRAME:AddMessage("After array reset: test_array.subarray found");

		if (test_array.subarray["fred"])
		then
			DEFAULT_CHAT_FRAME:AddMessage("After array reset: subarray entry was "..test_array.subarray["fred"]);
		else
			DEFAULT_CHAT_FRAME:AddMessage("After array reset: Subarray entry not found");
		end;
	else
		DEFAULT_CHAT_FRAME:AddMessage("After array reset: test_array.subarray not found");

		test_array.subarray = {};
		DEFAULT_CHAT_FRAME:AddMessage("Test subarray was (re)set");

		if (test_array.subarray["fred"])
		then
			DEFAULT_CHAT_FRAME:AddMessage("After subarray reset: subarray entry was "..test_array.subarray["fred"]);
		else
			DEFAULT_CHAT_FRAME:AddMessage("After subarray reset: Subarray entry not found");
		end;
	
	end;
		
end;

--
-- Display the current slots for known spells
--
function SN_SlotMap()

	local self = _G[SN_STRIKENOW_ROOT_FRAME];

	DEFAULT_CHAT_FRAME:AddMessage("Current slot map:");

	local slotSpellName, vv;

	for slotSpellName, slotArray in pairs(self.spells.slots) do

		DEFAULT_CHAT_FRAME:AddMessage(" "..slotSpellName);
		
		local slotNum, vv;

		for slotNum in pairs(self.spells.slots[slotSpellName]) do

			DEFAULT_CHAT_FRAME:AddMessage("   "..slotNum);
		end;
	end;
end;


--
-- Display the current slots for known spells
--
function SN_BarMap()

	local self = _G[SN_STRIKENOW_ROOT_FRAME];

	DEFAULT_CHAT_FRAME:AddMessage("Current bar map:");

	local barNum, buttonRoot;

	for barNum, buttonRoot in pairs(self.actionButtonRoot) do

		DEFAULT_CHAT_FRAME:AddMessage(" Actionbar"..barNum..": "..buttonRoot);
	end;
end;


function SN_ABToggles()

	-- Find any bars toggled visible

	local bottomLeftState, bottomRightState, sideRightState, sideRight2State = GetActionBarToggles();

	DEFAULT_CHAT_FRAME:AddMessage("The following toggle bars are supposedly visible:");
	if ( sideRightState )
	then
		DEFAULT_CHAT_FRAME:AddMessage("  sideRight");

		-- sideRight2 is dependent on sideRight
		if ( sideRight2State )
		then
			DEFAULT_CHAT_FRAME:AddMessage("  sideRight2/sideLeft)");
		end;
	end;

	if ( bottomRightState )
	then
		DEFAULT_CHAT_FRAME:AddMessage("  bottomRight");
	end;

	if ( bottomLeftState )
	then
		DEFAULT_CHAT_FRAME:AddMessage("  bottomLeft");
	end;

end;


